package trismegistoplanilla.mysqldao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import org.json.JSONObject;
import trismegistoplanilla.beans.AreaCargoTipoPagoBean;
import trismegistoplanilla.dao.EscalafonDAO;
import static trismegistoplanilla.utilities.CurrencyFormat.getCustomCurrency;
import trismegistoplanilla.utilities.ResponseHelper;
import trismegistoplanilla.utilities.Variables;

public class EscalafonMysqlDAO implements EscalafonDAO {

	@Override
	public JSONObject obtenerEscalafonAreaCargoTipoPago(AreaCargoTipoPagoBean actp) {
		System.out.println("EscalafonMysqlDAO: obtenerEscalafonAreaCargoTipoPago");
		JSONObject jsonObtenerEscalafonAreaCargo = null;
		ResponseHelper response = new ResponseHelper();

		String sql = ""
			+ "select "
			+ "sueldo "
			+ "from escalafon "
			+ "where codigo_area_cargo_tipo_pago = ? and estado_registro = 1";
		Connection cnx = null;
		PreparedStatement ps = null;
		ResultSet rs = null;
		String sueldo = "";
		try {
			cnx = MysqlDAOFactory.obtenerConexion(Variables.MYSQL_NUEVO_BD_NAME);
			ps = cnx.prepareStatement(sql);
			ps.setInt(1, actp.getCodigoAreaCargoTipoPago());
			rs = ps.executeQuery();
			if (rs.next()) {
				sueldo = getCustomCurrency(rs.getDouble("sueldo"));
				response.setStatus(true);
				JSONObject jsonObjSueldo = new JSONObject();
				jsonObjSueldo.put("sueldo", sueldo);
				response.setData(jsonObjSueldo);
			}
		} catch (SQLException e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error: " + e.getMessage() + " \n Error Code: [" + e.getErrorCode() + "]");
		} finally {
			try {
				if (rs != null) {
					rs.close();
				}
				if (ps != null) {
					ps.close();
				}
				if (cnx != null) {
					cnx.close();
				}
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}

		jsonObtenerEscalafonAreaCargo = new JSONObject(response);
		return jsonObtenerEscalafonAreaCargo;
	}

}
