package trismegistoplanilla.mysqldao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import org.json.JSONArray;
import org.json.JSONObject;
import trismegistoplanilla.beans.TipoEstadoFichaBean;
import trismegistoplanilla.dao.TipoEstadoFichaDAO;
import trismegistoplanilla.utilities.ResponseHelper;
import trismegistoplanilla.utilities.Variables;

public class TipoEstadoFichaMysqlDAO implements TipoEstadoFichaDAO {

	@Override
	public JSONObject listarTipoEstadoFicha() {
		System.out.println("TipoEstadoFichaMysqlDAO: listarTipoEstadoFicha");
		JSONObject JOlistarTipoEstadoFicha = null;
		JSONArray JAlistarTipoEstadoFicha = new JSONArray();
		ResponseHelper response = new ResponseHelper();

		String sql = ""
			+ "select "
			+ "codigo_tipo_estado_ficha codigoTipoEstadoFicha, "
			+ "nombre nombre, "
			+ "descripcion descripcion "
			+ "from tipo_estado_ficha "
			+ "where estado_registro = 1 "
			+ "order by 1";

		Connection conexion = null;
		PreparedStatement ps = null;
		ResultSet rs = null;
		try {
			conexion = MysqlDAOFactory.obtenerConexion(Variables.MYSQL_NUEVO_BD_NAME);
			ps = conexion.prepareStatement(sql);
			rs = ps.executeQuery();
			while (rs.next()) {
				TipoEstadoFichaBean tef = new TipoEstadoFichaBean();
				tef.setCodigoTipoEstadoFicha(rs.getInt("codigoTipoEstadoFicha"));
				tef.setNombre(rs.getString("nombre"));
				tef.setDescripcion(rs.getString("descripcion"));
				JSONObject objTipoEstadoFicha = new JSONObject(tef);
				JAlistarTipoEstadoFicha.put(objTipoEstadoFicha);
			}
			JSONObject objTipoEstadoFicha = new JSONObject();
			objTipoEstadoFicha.put("tiposEstadoFicha", JAlistarTipoEstadoFicha);
			response.setStatus(true);
			response.setMessage("Los tipos de estado de ficha se listaron correctamente");
			response.setData(objTipoEstadoFicha);
		} catch (SQLException e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error: " + e.getMessage() + " \n Error Code: [" + e.getErrorCode() + "]");
		} finally {
			try {
				if (rs != null) {
					rs.close();
				}
				if (ps != null) {
					ps.close();
				}
				if (conexion != null) {
					conexion.close();
				}
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		JOlistarTipoEstadoFicha = new JSONObject(response);
		return JOlistarTipoEstadoFicha;
	}

}
