package trismegistoplanilla.services;

import org.json.JSONObject;
import trismegistoplanilla.beans.EstadoFichaBean;
import trismegistoplanilla.beans.PersonaBean;
import trismegistoplanilla.beans.TokenFichaBean;
import trismegistoplanilla.dao.DAOFactory;
import trismegistoplanilla.dao.PersonaDAO;

public class PersonaService {

  DAOFactory factory = DAOFactory.getDAOFactory(DAOFactory.SQL_SERVER);
  PersonaDAO objPersonaDAO = factory.getPersonaDAO();

  public JSONObject validarExistenciaNumeroDocumento(PersonaBean p) {
    JSONObject jsonObjValidarExistenciaNumeroDocumento = null;
    try {
      jsonObjValidarExistenciaNumeroDocumento = objPersonaDAO.validarExistenciaNumeroDocumento(p);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return jsonObjValidarExistenciaNumeroDocumento;
  }

  public JSONObject validarExistenciaCorreoElectronico(PersonaBean p) {
    JSONObject jsonObjValidarExistenciaCorreoElectronico = null;
    try {
      jsonObjValidarExistenciaCorreoElectronico = objPersonaDAO.validarExistenciaCorreoElectronico(p);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return jsonObjValidarExistenciaCorreoElectronico;
  }

  public JSONObject registrarPersona(PersonaBean p, EstadoFichaBean ef, TokenFichaBean tf) {
    JSONObject jsonObjRegistrarPersona = null;
    try {
      jsonObjRegistrarPersona = objPersonaDAO.registrarPersona(p, ef, tf);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return jsonObjRegistrarPersona;
  }

  public JSONObject verificarPersona(TokenFichaBean tf, PersonaBean p) {
    JSONObject jsonObjVerificarPersona = null;
    try {
      jsonObjVerificarPersona = objPersonaDAO.verificarPersona(tf, p);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return jsonObjVerificarPersona;
  }

  public JSONObject obtenerCodigoPersona(TokenFichaBean tf) {
    JSONObject jsonObjObtenerCodigoPersona = null;
    try {
      jsonObjObtenerCodigoPersona = objPersonaDAO.obtenerCodigoPersona(tf);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return jsonObjObtenerCodigoPersona;
  }

  public JSONObject obtenerPersonaSession(PersonaBean p) {
    JSONObject jsonObjObtenerPersonaSession = null;
    try {
      jsonObjObtenerPersonaSession = objPersonaDAO.obtenerPersonaSession(p);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return jsonObjObtenerPersonaSession;
  }

}
