package trismegistoplanilla.servicesMysql;

import org.json.JSONObject;
import pe.siso.webservicesseguridad.webservices.UsuarioBean;
import trismegistoplanilla.beans.EstadoFichaBean;
import trismegistoplanilla.beans.FichaBean;
import trismegistoplanilla.beans.ObservacionFichaBean;
import trismegistoplanilla.beans.PersonaBean;
import trismegistoplanilla.beans.TokenFichaBean;
import trismegistoplanilla.dao.DAOFactory;
import trismegistoplanilla.dao.FichaDAO;

public class FichaServices {

  DAOFactory factory = DAOFactory.getDAOFactory(DAOFactory.MYSQL);
  FichaDAO objFichaDAO = factory.getFichaDAO();

  public JSONObject listarFichaDT(String draw, String length, String start, UsuarioBean u, JSONObject JOFiltro) {
    JSONObject jsonObjctListarFichaDT = null;
    try {
      jsonObjctListarFichaDT = objFichaDAO.listarFichaDT(draw, length, start, u, JOFiltro);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return jsonObjctListarFichaDT;
  }

  public JSONObject obtenerCodigoFicha(TokenFichaBean tf) {
    JSONObject jsonObjObtenerCodigoFicha = null;
    try {
      jsonObjObtenerCodigoFicha = objFichaDAO.obtenerCodigoFicha(tf);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return jsonObjObtenerCodigoFicha;
  }

  public JSONObject registrarFicha(JSONObject ficha, PersonaBean p, TokenFichaBean tf) {
    JSONObject jsonObjRegistrarFicha = null;
    try {
      jsonObjRegistrarFicha = objFichaDAO.registrarFicha(ficha, p, tf);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return jsonObjRegistrarFicha;
  }

  public JSONObject listarDatosFicha(PersonaBean persona) {
    JSONObject jsonReturn = null;
    try {
      jsonReturn = objFichaDAO.listarDatosFicha(persona);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return jsonReturn;
  }

  public JSONObject consultarFichasPorCriterio(String draw, int start, int length, String search, JSONObject criterioClient, UsuarioBean u) {
    JSONObject JOlistarFichas = null;
    try {
      JOlistarFichas = objFichaDAO.consultarFichasPorCriterio(draw, start, length, search, criterioClient, u);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return JOlistarFichas;
  }

  public JSONObject listarDetalleEstadoFicha(FichaBean f) {
    JSONObject JOlistarDetalleEstadoFicha = null;
    try {
      JOlistarDetalleEstadoFicha = objFichaDAO.listarDetalleEstadoFicha(f);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return JOlistarDetalleEstadoFicha;
  }

  public JSONObject listarDatosAdministrativos(FichaBean f) {
    JSONObject JOlistarDatosAdministrativos = null;
    try {
      JOlistarDatosAdministrativos = objFichaDAO.listarDatosAdministrativos(f);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return JOlistarDatosAdministrativos;
  }

  public JSONObject rechazarFicha(FichaBean f, EstadoFichaBean ef) {
    JSONObject JOrechazarFicha = null;
    try {
      JOrechazarFicha = objFichaDAO.rechazarFicha(f, ef);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return JOrechazarFicha;
  }

  public JSONObject aceptarFicha(FichaBean f, EstadoFichaBean ef) {
    JSONObject JOaceptarFicha = null;
    try {
      JOaceptarFicha = objFichaDAO.aceptarFicha(f, ef);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return JOaceptarFicha;
  }

  public JSONObject listarFichasPresidenciaDT(String draw, String length, String start, JSONObject search) {
    JSONObject jsonReturn = null;
    try {
      jsonReturn = objFichaDAO.listarFichasPresidenciaDT(draw, length, start, search);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return jsonReturn;
  }

  public JSONObject actualizarFicha(PersonaBean p, TokenFichaBean tf) {
    JSONObject JOactualizarFicha = null;
    try {
      JOactualizarFicha = objFichaDAO.actualizarFicha(p, tf);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return JOactualizarFicha;
  }

  public JSONObject anularFicha(EstadoFichaBean ef, ObservacionFichaBean of) {
    JSONObject JOanularFicha = null;
    try {
      JOanularFicha = objFichaDAO.anularFicha(ef, of);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return JOanularFicha;
  }

  public JSONObject verObservacion(EstadoFichaBean ef) {
    JSONObject JOverObservacion = null;
    try {
      JOverObservacion = objFichaDAO.verObservacion(ef);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return JOverObservacion;
  }

  public JSONObject listarFichasPresidencia() {
    JSONObject jsonReturn = null;
    try {
      jsonReturn = objFichaDAO.listarFichasPresidencia();
    } catch (Exception e) {
      e.printStackTrace();
    }
    return jsonReturn;
  }

  public JSONObject verificarExistenciaFichaAnulada(PersonaBean p) {
    JSONObject JOverificarExistenciaFichaAnulada = null;
    try {
      JOverificarExistenciaFichaAnulada = objFichaDAO.verificarExistenciaFichaAnulada(p);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return JOverificarExistenciaFichaAnulada;
  }

  public JSONObject obtenerCodigoPersonaPorTipoDocNroDoc(PersonaBean p) {
    JSONObject JOobtenerCodigoPersonaPorTipoDocNroDoc = null;
    try {
      JOobtenerCodigoPersonaPorTipoDocNroDoc = objFichaDAO.obtenerCodigoPersonaPorTipoDocNroDoc(p);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return JOobtenerCodigoPersonaPorTipoDocNroDoc;
  }

  public JSONObject habilitarFicha(PersonaBean p, UsuarioBean u, TokenFichaBean tf) {
    JSONObject JOhabilitarFicha = null;
    try {
      JOhabilitarFicha = objFichaDAO.habilitarFicha(p, u, tf);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return JOhabilitarFicha;
  }

  public JSONObject validarFichaActiva(PersonaBean p) {
    JSONObject JOvalidarFichaActiva = null;
    try {
      JOvalidarFichaActiva = objFichaDAO.validarFichaActiva(p);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return JOvalidarFichaActiva;
  }

}
