package trismegistoplanilla.sqlserverdao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import org.json.JSONObject;
import trismegistoplanilla.dao.ConfiguracionFichaDAO;
import trismegistoplanilla.utilities.ResponseHelper;
import trismegistoplanilla.utilities.Variables;

public class ConfiguracionFichaSqlserverDAO implements ConfiguracionFichaDAO {

	@Override
	public JSONObject getDefaultMail() {
		System.out.println("ConfiguracionFichaSqlserverDAO: getDefaultMail");
		JSONObject JOmail = null;
		ResponseHelper response = new ResponseHelper();
		String sql = ""
			+ "select "
			+ "correo "
			+ "from configuracion_ficha "
			+ "where estado = 1";
		Connection conexion = null;
		PreparedStatement ps = null;
		ResultSet rs = null;
		try {
			conexion = SqlserverDAOFactory.obtenerConexion(Variables.BD_NAME);
			ps = conexion.prepareStatement(sql);
			rs = ps.executeQuery();
			rs.next();
			JSONObject obj = new JSONObject();
			obj.put("mail", rs.getString("correo"));
			response.setData(obj);
			response.setStatus(true);
		} catch (SQLException e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error: " + e.getMessage() + " \n Error Code: [" + e.getErrorCode() + "]");
		} finally {
			try {
				if (rs != null) {
					rs.close();
				}
				if (ps != null) {
					ps.close();
				}
				if (conexion != null) {
					conexion.close();
				}
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		JOmail = new JSONObject(response);
		return JOmail;
	}

}
