package trismegistoplanilla.utilities;

import java.io.UnsupportedEncodingException;
import java.security.InvalidKeyException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKey;
import javax.crypto.spec.SecretKeySpec;
import org.apache.commons.codec.binary.Base64;

public class Encriptar {

  public static String secretKey = "";

  public static String encriptar(String texto, String secretKey) {
    String base64EncryptedString = "";
    try {
      MessageDigest md = MessageDigest.getInstance("MD5");
      byte[] digestOfPassword = md.digest(secretKey.getBytes("utf-8"));
      byte[] keyBytes = Arrays.copyOf(digestOfPassword, 24);
      SecretKey key = new SecretKeySpec(keyBytes, "DESede");
      Cipher cipher = Cipher.getInstance("DESede");
      cipher.init(Cipher.ENCRYPT_MODE, key);
      byte[] plainTextBytes = texto.getBytes("utf-8");
      byte[] buf = cipher.doFinal(plainTextBytes);
      byte[] base64Bytes = Base64.encodeBase64(buf);
      base64EncryptedString = new String(base64Bytes);
    } catch (UnsupportedEncodingException | InvalidKeyException | NoSuchAlgorithmException | BadPaddingException | IllegalBlockSizeException | NoSuchPaddingException ex) {
      ex.printStackTrace();
    }
    return base64EncryptedString;
  }

  public static String desencriptar(String textoEncriptado, String secretKey) throws Exception {
    String base64EncryptedString = "";
    try {
      byte[] message = Base64.decodeBase64(textoEncriptado.getBytes("utf-8"));
      MessageDigest md = MessageDigest.getInstance("MD5");
      byte[] digestOfPassword = md.digest(secretKey.getBytes("utf-8"));
      byte[] keyBytes = Arrays.copyOf(digestOfPassword, 24);
      SecretKey key = new SecretKeySpec(keyBytes, "DESede");
      Cipher decipher = Cipher.getInstance("DESede");
      decipher.init(Cipher.DECRYPT_MODE, key);
      byte[] plainText = decipher.doFinal(message);
      base64EncryptedString = new String(plainText, "UTF-8");
    } catch (UnsupportedEncodingException | InvalidKeyException | NoSuchAlgorithmException | BadPaddingException | IllegalBlockSizeException | NoSuchPaddingException ex) {
      ex.printStackTrace();
    }
    return base64EncryptedString;
  }

  public static boolean contieneCaracterEspecial(String cadena) {
    Pattern p = Pattern.compile("[^a-z0-9=]", Pattern.CASE_INSENSITIVE);
    Matcher m = p.matcher(cadena);
    return m.find();
  }

  public static ArrayList<Integer> posicionCaracterEspecial(String cadena) {
    ArrayList<Integer> posicion = new ArrayList<>();
    Pattern p = Pattern.compile("[^a-z0-9=]", Pattern.CASE_INSENSITIVE);
    Matcher m = p.matcher(cadena);
    while (m.find()) {
      posicion.add(m.start());
    }
    return posicion;
  }

  public static String[] reemplazar(String cadena) {
    String cadenaOriginal = cadena;
    String[] array = new String[2];
    array[0] = cadenaOriginal;
    if (contieneCaracterEspecial(cadena)) {
      ArrayList<Integer> posicion = posicionCaracterEspecial(cadena);
      for (int i = 0; i < posicion.size(); i++) {
        cadena = cadena.replace(cadena.charAt(posicion.get(i)), '-');
      }
    }
    array[1] = cadena;
    return array;
  }
}
