/* global jAlert, request */

const anularFicha = {
  anular() {
    $('#tblListadoFichaPendiente tbody').on('click', '.anularFicha', (e) => {
      let data = $('#tblListadoFichaPendiente').DataTable().row($(e.currentTarget).parents('tr')).data();
      jAlert({
        type: 'confirm',
        content: `
                <form action="" class="formName">
                  ¿Estás seguro de anular la ficha con número de documento <span class="bg-danger">${data.numeroDocumento}</span>?. <hr/>
                  <div class="form-group">
                  <label class="text-semibold">Ingrese el motivo:</label>
                  <textarea id="txtObservacion" class="form-control text-uppercase" rows="5" cols="30" style="resize:none;"></textarea>
                  <span class="text-size-small" style="color: #ff0505" ><b>NOTA:</b> Una vez confirmada la acción, no se podrá tener acceso a la ficha.</span>
                  </div>
                </form>
                 `,
        buttons: {
          left: 'SI',
          right: 'NO'
        }
      })
        .then(flag => {
          if (flag) {
            let observacion = $('#txtObservacion').val().toUpperCase().trim();
            if (!observacion) {
              warningMessage('Debe ingresar un motivo por el cual está anulando la ficha');
              return false;
            }
            let json = {
              codigoFicha: data.codigoFicha,
              observacion: observacion
            }
            request.anularFicha(json).then(response => {
              if (response.status) {
                successMessage(response.message);
                $('#tblListadoFichaPendiente').DataTable().ajax.reload();
              }
            });
          }
        })
    });
  }
}

anularFicha.anular();