/* global incializeComponents, getNode, request, jAlert */
let globalEditarFicha = {
  EDITAR_FICHA: {
    data: '',
    codigoSedeArea: 0,
    codigoAreaCargo: 0,
    tipoDocumento: {
      codigoTipoDocumento: 0,
      longitud: 0,
      tipoEntrada: '',
      numeroDocumento: ''
    },
    tieneCorreo: false,
    correoPorDefecto: '',
    correo: '',
    validadoPoReniec: false,
    errorReniec: false,
    persona: '',
    serviceFailure: {
      apellidoPaterno: '',
      apellidoMaterno: '',
      nombres: '',
      dni: ''
    }
  }
}

const editarFicha = {
  abrirModal() {
    $('#tblListadoFichaPendiente tbody').on('click', '.editarFicha', (e) => {
      $(getNode('#modalEditarFicha')).modal({
        show: true,
        backdrop: 'static',
        keyboard: false
      });
      let data = $('#tblListadoFichaPendiente').DataTable().row($(e.currentTarget).parents('tr')).data();
      globalEditarFicha.EDITAR_FICHA.data = data;
      editarFicha.cargarDatos();
      editarFicha.estadoTieneCorreo();
    });
  },

  cerrarModal() {
    getNode('#btnCancelarEditarFicha').addEventListener('click', (e) => {
      editarFicha.limpiar();
    });
  },

  estadoTieneCorreo() {
    let switcheryHTML = ``;
    if (globalEditarFicha.EDITAR_FICHA.data.tieneCorreo === 'SI') {
      globalEditarFicha.EDITAR_FICHA.tieneCorreo = true;
      switcheryHTML = `
                        <div class="checkbox-right checkbox-switchery switchery-xs">
                          <label>
                            <input type="checkbox" class="switcheryEdit" checked="checked">
                            <span class="text-semibold">¿Tiene correo?</span>
                          </label>&nbsp;&nbsp;&nbsp;
                          <span class="text-black" id="estadoSwitchery">SI</span>
                        </div>
                        `;
      getNode('#txtCorreoEditarFicha').removeAttribute('disabled');
      getNode('#switcheryHTMLEditarFicha').innerHTML = switcheryHTML;
    } else {
      globalEditarFicha.EDITAR_FICHA.tieneCorreo = false;
      switcheryHTML = `
                        <div class="checkbox-right checkbox-switchery switchery-xs">
                          <label>
                            <input type="checkbox" class="switcheryEdit">
                            <span class="text-semibold">¿Tiene correo?</span>
                          </label>&nbsp;&nbsp;&nbsp;
                          <span class="text-black" id="estadoSwitchery">NO</span>
                        </div>
                        `;
      getNode('#txtCorreoEditarFicha').setAttribute('disabled', true);
      getNode('#switcheryHTMLEditarFicha').innerHTML = switcheryHTML;
    }
    let elem = document.querySelector('.switcheryEdit');
    let switchery = new Switchery(elem, {color: '#4CAF50', secondaryColor: '#EF5350'});
    elem.onclick = () => {
      if (elem.checked) {
        getNode('#estadoSwitchery').innerHTML = 'SI'
        globalEditarFicha.EDITAR_FICHA.tieneCorreo = true;
        getNode('#txtCorreoEditarFicha').removeAttribute('disabled');
        getNode('#txtCorreoEditarFicha').value = '';
      } else {
        getNode('#estadoSwitchery').innerHTML = 'NO'
        globalEditarFicha.EDITAR_FICHA.tieneCorreo = false;
        getNode('#txtCorreoEditarFicha').setAttribute('disabled', true)
        getNode('#txtCorreoEditarFicha').value = globalEditarFicha.EDITAR_FICHA.correoPorDefecto;
        globalEditarFicha.EDITAR_FICHA.correo = globalEditarFicha.EDITAR_FICHA.correoPorDefecto;
      }
    }
  },

  obtenerCorreoPorDefecto() {
    request.obtenerCorreoPorDefecto().then(response => {
      globalEditarFicha.EDITAR_FICHA.correoPorDefecto = response.data.mail.toUpperCase();
    });
  },

  cargarDatos() {
    // listar sede
    editarFicha.listarSede();

    // listar area
    editarFicha.listarArea();

    // listar cargo
    editarFicha.listarCargos();

    // listar tipo de documento
    editarFicha.listarTipoDocumento();

    // cargar numero documento
    getNode('#txtNumeroDocumentoEditarFicha').value = globalEditarFicha.EDITAR_FICHA.data.numeroDocumento;
    getNode('#txtNumeroDocumentoEditarFicha').setAttribute('minlength', globalEditarFicha.EDITAR_FICHA.data.longitud)
    getNode('#txtNumeroDocumentoEditarFicha').setAttribute('maxlength', globalEditarFicha.EDITAR_FICHA.data.longitud)
    $(getNode('#txtNumeroDocumentoEditarFicha')).off();
    globalEditarFicha.EDITAR_FICHA.data.tipoEntrada === 'N' ? "" + $(getNode('#txtNumeroDocumentoEditarFicha')).validCampo('1234567890') : "" + $(getNode('#txtNumeroDocumentoEditarFicha')).validCampo('1234567890abcdefghijklmnopqrstuvwxyz');
    globalEditarFicha.EDITAR_FICHA.tipoDocumento.numeroDocumento = globalEditarFicha.EDITAR_FICHA.data.numeroDocumento;
    getNode('#txtNumeroDocumentoEditarFicha').addEventListener('blur', (e) => {
      globalEditarFicha.EDITAR_FICHA.tipoDocumento.numeroDocumento = e.currentTarget.value;
    });


    // cargar correo
    getNode('#txtCorreoEditarFicha').value = globalEditarFicha.EDITAR_FICHA.data.correo.toUpperCase();
    globalEditarFicha.EDITAR_FICHA.correo = globalEditarFicha.EDITAR_FICHA.data.correo.toUpperCase();
    if (globalEditarFicha.EDITAR_FICHA.data.tieneCorreo === 'SI') {
      globalEditarFicha.EDITAR_FICHA.tieneCorreo = true;
    } else {
      globalEditarFicha.EDITAR_FICHA.tieneCorreo = false;
    }
    getNode('#txtCorreoEditarFicha').addEventListener('blur', (e) => {
      globalEditarFicha.EDITAR_FICHA.correo = e.currentTarget.value.toUpperCase().trim();
    });
  },

  listarSede() {
    request.listarSede().then((sedes) => {
      getNode('#cboSedeEditarFicha').innerHTML = createSelectOptions(sedes, 'codigoSede', 'nombre');
      return sedes;
    })
      .then(sedes => {
        let codigoSedeData = parseInt(globalEditarFicha.EDITAR_FICHA.data.sedeAreaCargo.split('-')[0]);
        sedes.map(data => {
          if (codigoSedeData === data.codigoSede) {
            $(getNode('#cboSedeEditarFicha')).val(codigoSedeData).trigger('change');
          }
        })
      });
  },

  listarArea() {
    getNode('#cboSedeEditarFicha').onchange = (e) => {
      getNode('#cboAreaEditarFicha').innerHTML = '<option value="0">[SELECCIONAR]</option>';
      getNode('#cboCargoEditarFicha').innerHTML = '<option value="0">[SELECCIONAR]</option>';
      $(e.currentTarget).valid();
      if (!isNaN(e.currentTarget.value)) {
        let codigoSede = parseInt(e.currentTarget.value);
        if (codigoSede !== 0) {
          request.listarArea(codigoSede).then((areas) => {
            getNode('#cboAreaEditarFicha').innerHTML = createSelectOptions(areas, 'codigoArea', 'nombre');
            return areas;
          })
            .then(areas => {
              let codigoAreaData = parseInt(globalEditarFicha.EDITAR_FICHA.data.sedeAreaCargo.split('-')[1]);
              areas.map(data => {
                if (codigoAreaData === data.codigoArea) {
                  $(getNode('#cboAreaEditarFicha')).val(codigoAreaData).trigger('change');
                }
              });
            });
        }
      }
    }
  },

  listarCargos() {
    getNode('#cboAreaEditarFicha').onchange = (e) => {
      getNode('#cboCargoEditarFicha').innerHTML = '<option value="0">[SELECCIONAR]</option>';
      $(e.currentTarget).valid();
      if (!isNaN(e.currentTarget.value)) {
        let codigoSede = parseInt(getNode('#cboSedeEditarFicha').value);
        let codigoArea = parseInt(e.currentTarget.value);
        let data = {codigoSede: codigoSede, codigoArea: codigoArea};
        if (codigoArea !== 0) {
          request.listarCargo(codigoArea).then((cargos) => {
            getNode('#cboCargoEditarFicha').innerHTML = createSelectOptions(cargos, 'codigoCargo', 'nombre');
            return cargos;
          })
            .then(cargos => {
              let codigoCargoData = parseInt(globalEditarFicha.EDITAR_FICHA.data.sedeAreaCargo.split('-')[2]);
              cargos.map(data => {
                if (codigoCargoData === data.codigoCargo) {
                  $(getNode('#cboCargoEditarFicha')).val(codigoCargoData).trigger('change');
                }
              });
              return data;
            })
            .then(data => {
              request.obtenerSedeArea(data.codigoSede, data.codigoArea).then((response) => {
                globalEditarFicha.EDITAR_FICHA.codigoSedeArea = response;
              });
            });
        }
      }
    }

    getNode('#cboCargoEditarFicha').onchange = (e) => {
      $(e.currentTarget).valid();
      if (!isNaN(e.currentTarget.value)) {
        let codigoArea = parseInt(getNode('#cboAreaEditarFicha').value);
        let codigoCargo = parseInt(e.currentTarget.value);
        if (codigoCargo !== 0) {
          request.obtenerAreaCargo(codigoArea, codigoCargo).then((response) => {
            globalEditarFicha.EDITAR_FICHA.codigoAreaCargo = response;
          });
        }
      }
    }
  },

  listarTipoDocumento() {
    request.listarTipoDocumento().then((tipoDocumentos) => {
      getNode('#cboTipoDocumentoEditarFicha').innerHTML = createSelectOptions(tipoDocumentos, 'codigoTipoDocumento', 'descripcionCorta');
      return tipoDocumentos;
    })
      .then(tipoDocumentos => {
        let codigoTipoDocumentoData = parseInt(globalEditarFicha.EDITAR_FICHA.data.codigoTipoDocumento);
        $(getNode('#cboTipoDocumentoEditarFicha')).val(codigoTipoDocumentoData).trigger('change');
        globalEditarFicha.EDITAR_FICHA.tipoDocumento.codigoTipoDocumento = codigoTipoDocumentoData;
        globalEditarFicha.EDITAR_FICHA.tipoDocumento.longitud = parseInt(globalEditarFicha.EDITAR_FICHA.data.longitud);
        globalEditarFicha.EDITAR_FICHA.tipoDocumento.tipoEntrada = globalEditarFicha.EDITAR_FICHA.data.tipoEntrada;

        // limpiar variables
        getNode('#linkValidarDNIEditarFicha').innerHTML = '';
        getNode('#respuestaHTMLEditarFicha').innerHTML = ``;
        globalEditarFicha.EDITAR_FICHA.persona = '';
        globalEditarFicha.EDITAR_FICHA.validadoPoReniec = false;

        editarFicha.pintarLinkConsultarDNI();

        getNode('#cboTipoDocumentoEditarFicha').onchange = (e) => {
          $(e.currentTarget).valid();
          if (!isNaN(e.currentTarget.value)) {
            // limpiar variables
            getNode('#linkValidarDNIEditarFicha').innerHTML = '';
            getNode('#respuestaHTMLEditarFicha').innerHTML = ``;
            globalEditarFicha.EDITAR_FICHA.persona = '';
            globalEditarFicha.EDITAR_FICHA.validadoPoReniec = false;
            globalEditarFicha.EDITAR_FICHA.serviceFailure.apellidoPaterno = '';
            globalEditarFicha.EDITAR_FICHA.serviceFailure.apellidoMaterno = '';
            globalEditarFicha.EDITAR_FICHA.serviceFailure.nombres = '';
            globalEditarFicha.EDITAR_FICHA.errorReniec = false;
            getNode('#ventanaEmergenciaEditarFicha').innerHTML = '';

            let codigoTipoDocumento = parseInt(e.currentTarget.value);
            if (codigoTipoDocumento !== 0) {

              if (globalEditarFicha.EDITAR_FICHA.data.codigoTipoDocumento !== codigoTipoDocumento) {
                getNode('#txtNumeroDocumentoEditarFicha').value = '';
              }

              tipoDocumentos.map(data => {
                if (codigoTipoDocumento === data.codigoTipoDocumento) {
                  getNode('#txtNumeroDocumentoEditarFicha').setAttribute('minlength', data.longitud)
                  getNode('#txtNumeroDocumentoEditarFicha').setAttribute('maxlength', data.longitud)
                  $(getNode('#txtNumeroDocumentoEditarFicha')).off();
                  data.tipoEntrada === 'N' ? "" + $(getNode('#txtNumeroDocumentoEditarFicha')).validCampo('1234567890') : "" + $(getNode('#txtNumeroDocumentoEditarFicha')).validCampo('1234567890abcdefghijklmnopqrstuvwxyz');
                  globalEditarFicha.EDITAR_FICHA.tipoDocumento.codigoTipoDocumento = codigoTipoDocumento;
                  globalEditarFicha.EDITAR_FICHA.tipoDocumento.longitud = parseInt(data.longitud);
                  globalEditarFicha.EDITAR_FICHA.tipoDocumento.tipoEntrada = data.tipoEntrada;

                  editarFicha.pintarLinkConsultarDNI();
                }
              });
            }
          }
          validFormEditarFicha.reglas();
        };
      });
  },

  validarCambios() {
    let flag = false;
    // validar sedeArea
    let codigoSedeAreaOld = parseInt(globalEditarFicha.EDITAR_FICHA.data.codigoSedeAreaAreaCargo.split('-')[0]);
    let codigoSedeAreaNew = globalEditarFicha.EDITAR_FICHA.codigoSedeArea;
    if (codigoSedeAreaOld !== codigoSedeAreaNew) {
      flag = true;
    }

    // validar areaCargo
    let codigoAreaCargoOld = parseInt(globalEditarFicha.EDITAR_FICHA.data.codigoSedeAreaAreaCargo.split('-')[1]);
    let codigoAreaCargoNew = globalEditarFicha.EDITAR_FICHA.codigoAreaCargo;
    if (codigoAreaCargoOld !== codigoAreaCargoNew) {
      flag = true;
    }

    // validar tipo documento
    let codigoTipoDocumentoOld = globalEditarFicha.EDITAR_FICHA.data.codigoTipoDocumento;
    let codigoTipoDocumentoNew = globalEditarFicha.EDITAR_FICHA.tipoDocumento.codigoTipoDocumento;
    if (codigoTipoDocumentoOld !== codigoTipoDocumentoNew) {
      flag = true;
    }

    // validar numero documento
    let numeroDocumentoOld = globalEditarFicha.EDITAR_FICHA.data.numeroDocumento;
    let numeroDocumentoNew = globalEditarFicha.EDITAR_FICHA.tipoDocumento.numeroDocumento;
    if (numeroDocumentoOld !== numeroDocumentoNew) {
      flag = true;
    }
    // validar correo
    let correoOld = globalEditarFicha.EDITAR_FICHA.data.correo;
    let correoNew = globalEditarFicha.EDITAR_FICHA.correo;
    if (correoOld !== correoNew) {
      flag = true;
    }
    return flag;
  },

  pintarLinkConsultarDNI() {
    getNode('#linkValidarDNIEditarFicha').innerHTML = '';
    if (globalEditarFicha.EDITAR_FICHA.tipoDocumento.codigoTipoDocumento === 1) {
      getNode('#linkValidarDNIEditarFicha').innerHTML = `<a id="consultarDNIEditarFicha" class="text-bold text-success-800 border" title="[VALIDA CON RENIEC LA EXISTENCIA DEL DNI INGRESADO]"><i class="fa fa-search position-left"></i>Consultar DNI</a>`;
      this.consultarDNI();
    }
  },

  consultarDNI() {
    getNode('#consultarDNIEditarFicha').addEventListener('click', (e) => {
      let numeroDocumentoOld = globalEditarFicha.EDITAR_FICHA.data.numeroDocumento;
      let numeroDocumentoNew = globalEditarFicha.EDITAR_FICHA.tipoDocumento.numeroDocumento;
      let longitudTipoDocumento = globalEditarFicha.EDITAR_FICHA.tipoDocumento.longitud;
      // ¿hubo cambio en el numero de documento?
      if (numeroDocumentoOld !== numeroDocumentoNew) { // SI
        // ¿el nuevo numero de documento "DNI" tiene 8 digitos?
        if (numeroDocumentoNew.length === longitudTipoDocumento) { // SI
          // Ejecutar método que valida la existencia del número de documento ingresado
          let tipoDocumentoJson = globalEditarFicha.EDITAR_FICHA.tipoDocumento;
          request.validarExistenciaNumeroDocumento(tipoDocumentoJson).then(response => {
            // ¿El número de documento ingresado existe en el sistema?
            if (response.status) { // NO
              // Ejecutar método que valida el dni ingresado con el servicio TECACTUS -> (RENIEC)
              request.consultarDNI(numeroDocumentoNew).then(response => {
                globalEditarFicha.EDITAR_FICHA.persona = response;
                let respuestaHTML = ``;
                // ¿ el método devolvió a la persona ?
                if (!globalEditarFicha.EDITAR_FICHA.persona.empty) { // SI
                  globalEditarFicha.EDITAR_FICHA.validadoPoReniec = true;
                  respuestaHTML = `
                  <div class="alert alert-success alert-styled-left alert-arrow-left alert-bordered">
                    <span class="text-bold">RESPUESTA DE RENIEC: </span> 
                    ${globalEditarFicha.EDITAR_FICHA.persona.apellidoPaterno + ' '
                    + globalEditarFicha.EDITAR_FICHA.persona.apellidoMaterno + ' '
                    + globalEditarFicha.EDITAR_FICHA.persona.nombres +
                    ' (<span class="text-semibold">' + globalEditarFicha.EDITAR_FICHA.persona.dni + '</span>)'}
                  </div>`;
                } else { // NO
                  respuestaHTML = `
                  <div class="alert alert-danger alert-styled-left alert-arrow-left alert-bordered">
                    <span class="text-bold">RESPUESTA DE RENIEC: </span> ${globalEditarFicha.EDITAR_FICHA.persona.message}
                  </div>`;
                }
                getNode('#respuestaHTMLEditarFicha').innerHTML = respuestaHTML;
              })
                .catch(error => {
                  globalEditarFicha.EDITAR_FICHA.errorReniec = true;
                  if (error.statusCodeTecactus === -1) {
                    let ventanaEmergenciaHTML = `
                    <div class="panel border-danger">
                      <div class="panel-heading bg-danger">
                        <h6 class="panel-title"><i class="fa fa-warning"></i> &nbsp; Ventana de emergencia</h6>
                        <a class="heading-elements-toggle"><i class="icon-more"></i></a>
                      </div>
                      <div class="panel-body">
                        <div class="row">
                          <div class="col-md-12">
                            <div class="alert alert-warning">
                              <span class="text-semibold">FALLA DEL SERVICIO TECACTUS (<ins><i>Servicio que se conecta con RENIEC para la validación de DNI</i></ins>) </span> <br/>
                              <span>
                                Al parecer el servicio <ins>TECACTUS</ins> está fallando, asimismo se ha activado el <b>plan de contingencia</b>, el cuál
                                cubre la necesidad parcial del registro de ficha. Por favor ingrese los datos que se le solicitan en está ventana, Gracias.
                              </span> <br/>
                              <span class="text-muted text-semibold">* El servicio se estará restableciendo pronto.</span>
                            </div>
                          </div>
                        </div>
                        <div class="row">
                          <div class="col-md-4">
                            <div class="form-group">
                              <label for="txtApellidoPaternoEditarFicha" class="text-semibold">Apellido Paterno <span class="text-danger">(*)</span></label>
                              <input type="text" class="form-control text-uppercase" placeholder="Ingresar apellido paterno" id="txtApellidoPaternoEditarFicha" name="txtApellidoPaternoEditarFicha" maxlength="50" autocomplete="off" required>
                            </div>
                          </div>
                          <div class="col-md-4">
                            <div class="form-group">
                              <label for="txtApellidoMaternoEditarFicha" class="text-semibold">Apellido Materno <span class="text-danger">(*)</span></label>
                              <input type="text" class="form-control text-uppercase" placeholder="Ingresar apellido materno" id="txtApellidoMaternoEditarFicha" name="txtApellidoMaternoEditarFicha" maxlength="50" autocomplete="off" required>
                            </div>
                          </div>
                          <div class="col-md-4">
                            <div class="form-group">
                              <label for="txtNombresEditarFicha" class="text-semibold">Nombres <span class="text-danger">(*)</span></label>
                              <input type="text" class="form-control text-uppercase" placeholder="Ingresar nombres" id="txtNombresEditarFicha" name="txtNombresEditarFicha" maxlength="50" autocomplete="off" required>
                            </div>
                          </div>
                        </div>
                      </div>
                    </div>`;
                    getNode('#ventanaEmergenciaEditarFicha').innerHTML = ventanaEmergenciaHTML;
                    $(getNode('#txtApellidoPaternoEditarFicha')).validCampo('abcdefghijklmnñopqrstuvwxyzáéíóú ');
                    $(getNode('#txtApellidoMaternoEditarFicha')).validCampo('abcdefghijklmnñopqrstuvwxyzáéíóú ');
                    $(getNode('#txtNombresEditarFicha')).validCampo('abcdefghijklmnñopqrstuvwxyzáéíóú ');
                    editarFicha.llenarDatosServiceFailure();
                    validFormEditarFicha.reglas();
                  }
                });
            } else { // SI
              warningMessage(response.message);
            }
          });
        } else { // NO
          warningMessage(`El número de documento no es un DNI válido, por favor ingrese <mark>${longitudTipoDocumento}</mark> dígitos`);
        }
      } else { // NO
        let personalValidado = `${globalEditarFicha.EDITAR_FICHA.data.apellidoPaterno} 
                                  ${globalEditarFicha.EDITAR_FICHA.data.apellidoMaterno}, 
                                  ${globalEditarFicha.EDITAR_FICHA.data.nombre} 
                                  (${globalEditarFicha.EDITAR_FICHA.data.numeroDocumento})`;
        warningMessage(`El sistema ha detectado que el DNI ya ha sido validado y le pertenece a: <br/> <span class="text-blue-800">${personalValidado}</span>. <br/><hr/>
                        Si se ha equivocado en digitar el DNI, por favor ingrese el DNI correcto y valide dando clic en <span class=text-muted>"Consultar DNI"</span> .`);
      }
    });
  },

  llenarDatosServiceFailure() {
    if (globalEditarFicha.EDITAR_FICHA.errorReniec) {
      globalEditarFicha.EDITAR_FICHA.serviceFailure.dni = globalEditarFicha.EDITAR_FICHA.tipoDocumento.numeroDocumento;
      getNode('#txtApellidoPaternoEditarFicha').addEventListener('blur', (e) => {
        globalEditarFicha.EDITAR_FICHA.serviceFailure.apellidoPaterno = e.currentTarget.value.toUpperCase().trim();
      });
      getNode('#txtApellidoMaternoEditarFicha').addEventListener('blur', (e) => {
        globalEditarFicha.EDITAR_FICHA.serviceFailure.apellidoMaterno = e.currentTarget.value.toUpperCase().trim();
      });
      getNode('#txtNombresEditarFicha').addEventListener('blur', (e) => {
        globalEditarFicha.EDITAR_FICHA.serviceFailure.nombres = e.currentTarget.value.toUpperCase().trim();
      });
    }
  },

  consultarDNIAfter(flag) {
    if (flag) {
      getNode('#consultarDNIEditarFicha').innerHTML = '<i class="fa fa-undo position-left"></i> Consultar otro DNI'
      getNode('#consultarDNIEditarFicha').setAttribute('class', 'text-bold text-danger-800');
      getNode('#txtNumeroDocumentoEditarFicha').setAttribute('disabled', true);
    } else {
      getNode('#consultarDNIEditarFicha').innerHTML = '<i class="fa fa-search position-left"></i> Consultar DNI'
      getNode('#consultarDNIEditarFicha').setAttribute('class', 'text-bold text-success-800');
      getNode('#txtNumeroDocumentoEditarFicha').removeAttribute('disabled');
      getNode('#txtNumeroDocumentoEditarFicha').value = '';
      getNode('#respuestaHTMLEditarFicha').innerHTML = '';
      globalEditarFicha.EDITAR_FICHA.persona = '';
      globalEditarFicha.EDITAR_FICHA.validadoPoReniec = false;
      globalEditarFicha.EDITAR_FICHA.serviceFailure.apellidoPaterno = '';
      globalEditarFicha.EDITAR_FICHA.serviceFailure.apellidoMaterno = '';
      globalEditarFicha.EDITAR_FICHA.serviceFailure.nombres = '';
      globalEditarFicha.EDITAR_FICHA.serviceFailure.dni = '';
      globalEditarFicha.EDITAR_FICHA.errorReniec = false;
      getNode('#ventanaEmergenciaEditarFicha').innerHTML = '';
    }
  },

  validarNumeroDocumentoCorreoElectronico() {
    return new Promise((resolve, reject) => {
      let validacion = true;

      // validar si el numero de documento ha cambiado
      let codigoTipoDocumentoNew = globalEditarFicha.EDITAR_FICHA.tipoDocumento.codigoTipoDocumento;
      let longitudNumeroDocumentoNew = globalEditarFicha.EDITAR_FICHA.tipoDocumento.longitud;
      let numeroDocumentoOld = globalEditarFicha.EDITAR_FICHA.data.numeroDocumento;
      let numeroDocumentoNew = globalEditarFicha.EDITAR_FICHA.tipoDocumento.numeroDocumento;
      let errorReniec = globalEditarFicha.EDITAR_FICHA.errorReniec;
      let validadoPoReniec = globalEditarFicha.EDITAR_FICHA.validadoPoReniec;

      if (codigoTipoDocumentoNew === 1 && numeroDocumentoOld !== numeroDocumentoNew && numeroDocumentoNew.length === longitudNumeroDocumentoNew && !errorReniec && !validadoPoReniec) {
        warningMessage('Por favor, valide el dni ingresado dando clic en "Consultar DNI"');
        validacion = false;
        resolve(validacion);
      }

      if (codigoTipoDocumentoNew !== 1 && numeroDocumentoNew.length !== longitudNumeroDocumentoNew) {
        warningMessage(`El número de documento debe tener <mark>${longitudNumeroDocumentoNew}</mark> dígitos`)
        validacion = false;
        resolve(validacion);
      }


      // validar si el correo ha cambiado
      let correoOld = globalEditarFicha.EDITAR_FICHA.data.correo;
      let correoNew = globalEditarFicha.EDITAR_FICHA.correo;
      let tieneCorreo = globalEditarFicha.EDITAR_FICHA.tieneCorreo;
      if (tieneCorreo) {
        if (correoOld !== correoNew) {
          request.validarExistenciaCorreo(correoNew).then(response => {
            if (!response.status) {
              warningMessage(response.message);
              validacion = false;
              resolve(validacion);
            }
          });
        }
      }

      resolve(validacion);

    });
  },

  actualizarFicha() {
    let obj = {
      type: 'confirm',
      content: '¿Está seguro que desea actualizar la ficha?',
      buttons: {
        left: 'Si',
        right: 'No'
      }
    }
    jAlert(obj).then(flag => {
      if (flag) {
        request.actualizarFicha(globalEditarFicha.EDITAR_FICHA).then(response => {
          if (response.status) {
            $('#tblListadoFichaPendiente').DataTable().ajax.reload();
            jAlert({
              type: 'success',
              content: response.message,
              buttons: {
                left: 'Aceptar'
              }
            });
            editarFicha.limpiar();
          } else {
            jAlert({
              type: 'error',
              content: response.message,
              buttons: {
                left: 'Aceptar'
              }
            });
          }
        });
      }
    });
  },

  limpiar() {
    globalEditarFicha = {
      EDITAR_FICHA: {
        data: '',
        codigoSedeArea: 0,
        codigoAreaCargo: 0,
        tipoDocumento: {
          codigoTipoDocumento: 0,
          longitud: 0,
          tipoEntrada: '',
          numeroDocumento: ''
        },
        tieneCorreo: false,
        correoPorDefecto: '',
        correo: '',
        validadoPoReniec: false,
        errorReniec: false,
        persona: '',
        serviceFailure: {
          apellidoPaterno: '',
          apellidoMaterno: '',
          nombres: '',
          dni: ''
        }
      }
    }

    this.obtenerCorreoPorDefecto();

    let validator = $("#formEditarFicha").validate();
    validator.resetForm();

    $(getNode('#modalEditarFicha')).modal('hide');
  }

}

const validFormEditarFicha = {
  reglas() {
    // select sede
    $(getNode('#cboSedeEditarFicha')).rules('add', {
      valueNotEquals: '0'
    });

    // select área
    $(getNode('#cboAreaEditarFicha')).rules('add', {
      valueNotEquals: '0'
    });

    // select cargo
    $(getNode('#cboCargoEditarFicha')).rules('add', {
      valueNotEquals: '0'
    });

    // select tipo de documento
    $(getNode('#cboTipoDocumentoEditarFicha')).rules('add', {
      valueNotEquals: '0'
    });

    // input numero documento
    if (globalEditarFicha.EDITAR_FICHA.tipoDocumento.tipoEntrada === 'N') {
      $('#txtNumeroDocumentoEditarFicha').rules('remove', 'alphanumeric');
      $(getNode('#txtNumeroDocumentoEditarFicha')).rules('add', {
        number: true
      });
    } else if (globalEditarFicha.EDITAR_FICHA.tipoDocumento.tipoEntrada === 'A') {
      $('#txtNumeroDocumentoEditarFicha').rules('remove', 'number');
      $(getNode('#txtNumeroDocumentoEditarFicha')).rules('add', {
        alphanumeric: true
      });
    }

    // apellido paterno
    $(getNode('#txtApellidoPaternoEditarFicha')).rules('add', {
      required: true,
      lettersonly: true
    });

    // apellido paterno
    $(getNode('#txtApellidoMaternoEditarFicha')).rules('add', {
      required: true,
      lettersonly: true
    });

    // apellido paterno
    $(getNode('#txtNombresEditarFicha')).rules('add', {
      required: true,
      lettersonly: true
    });

  },

  validarFormularioEditarFicha() {
    $(getNode('#formEditarFicha')).validate({
      submitHandler: function (form) {
        if (editarFicha.validarCambios()) {
          editarFicha.validarNumeroDocumentoCorreoElectronico().then(response => {
            if (response) {
              editarFicha.actualizarFicha();
            }
          });
        } else {
          jAlert({
            type: 'warning',
            content: 'El sistema ha detectado que no se ha realizado ningún cambio, por lo tanto la actualización de la ficha no podrá ser ejecutada.',
            buttons: {
              left: 'Aceptar'
            }
          });
        }
        return false;
      }
    });
  }
}

editarFicha.obtenerCorreoPorDefecto();
incializeComponents.select2ById('cboSedeEditarFicha');
incializeComponents.select2ById('cboAreaEditarFicha');
incializeComponents.select2ById('cboCargoEditarFicha');
incializeComponents.select2ById('cboTipoDocumentoEditarFicha');
editarFicha.abrirModal();
editarFicha.cerrarModal();
validFormEditarFicha.validarFormularioEditarFicha();
validFormEditarFicha.reglas();