/* global Infinity */

const getNode = node => document.querySelector(node);
const incializeComponents = {
  select2() {
    $(getNode('.select')).select2({
      minimumResultsForSearch: Infinity
    });
  },

  select2ById(id) {
    $('#' + id).select2({
      minimumResultsForSearch: Infinity
    });
  },

  selectDatePicker() {
    $(".datepicker").prop('readonly', true);
    $(".datepicker").datepicker({
      dateFormat: 'dd/mm/yy',
      showButtonPanel: false,
      changeMonth: true,
      changeYear: true
    });
    let date = new Date();
    $(".datepicker").datepicker("setDate", date);
    $.datepicker.regional['es'] = {
      closeText: 'Cerrar',
      prevText: '<Ant',
      nextText: 'Sig>',
      currentText: 'Hoy',
      monthNames: ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'],
      monthNamesShort: ['Ene', 'Feb', 'Mar', 'Abr', 'May', 'Jun', 'Jul', 'Ago', 'Sep', 'Oct', 'Nov', 'Dic'],
      dayNames: ['Domingo', 'Lunes', 'Martes', 'Miércoles', 'Jueves', 'Viernes', 'Sábado'],
      dayNamesShort: ['Dom', 'Lun', 'Mar', 'Mié', 'Juv', 'Vie', 'Sáb'],
      dayNamesMin: ['Do', 'Lu', 'Ma', 'Mi', 'Ju', 'Vi', 'Sá'],
      weekHeader: 'Sm',
      dateFormat: 'dd/mm/yy',
      firstDay: 1,
      isRTL: false,
      showMonthAfterYear: false,
      yearSuffix: ''
    };
    $.datepicker.setDefaults($.datepicker.regional['es']);
  },
}

incializeComponents.select2();
incializeComponents.selectDatePicker();