/* global getNode, incializeComponents, request, jAlert */
let globalNuevaFicha = {
  NUEVA_FICHA: {
    codigoPersona: 0,
    codigoSedeArea: 0,
    codigoAreaCargo: 0,
    flags: {
      vacante: false
    },
    tipoDocumento: {
      codigoTipoDocumento: 0,
      longitud: 0,
      tipoEntrada: '',
      numeroDocumento: ''
    },
    tieneCorreo: true,
    correoPorDefecto: '',
    correo: '',
    validadoPoReniec: false,
    errorReniec: false,
    persona: '',
    serviceFailure: {
      apellidoPaterno: '',
      apellidoMaterno: '',
      nombres: '',
      dni: ''
    }
  }
}

const nuevaFicha = {
  abrirModal() {
    getNode('#btnAbrirModalRegistrarNuevaFicha').addEventListener('click', (e) => {
      $(getNode('#modalRegistrarNuevaFicha')).modal({
        show: true,
        backdrop: 'static',
        keyboard: false
      });
      nuevaFicha.estadoTieneCorreo();
    });
  },

  cerrarModal() {
    getNode('#btnCancelarRegistarNuevaFicha').addEventListener('click', (e) => {
      nuevaFicha.limpiar();
    });
  },

  estadoTieneCorreo() {
    let switcheryHTML = `
                        <div class="checkbox-right checkbox-switchery switchery-xs">
                          <label>
                            <input type="checkbox" class="switchery" checked="checked">
                            <span class="text-semibold">¿Tiene correo?</span>
                          </label>&nbsp;&nbsp;&nbsp;
                          <span class="text-black" id="estadoSwitchery">SI</span>
                        </div>
                        `;
    getNode('#switcheryHTML').innerHTML = switcheryHTML;
    let elem = document.querySelector('.switchery');
    let switchery = new Switchery(elem, {color: '#4CAF50', secondaryColor: '#EF5350'});
    getNode('#txtCorreoNuevaFicha').removeAttribute('disabled');
    elem.onclick = () => {
      if (elem.checked) {
        getNode('#estadoSwitchery').innerHTML = 'SI'
        globalNuevaFicha.NUEVA_FICHA.tieneCorreo = true;
        getNode('#txtCorreoNuevaFicha').removeAttribute('disabled');
        getNode('#txtCorreoNuevaFicha').value = ''
      } else {
        getNode('#estadoSwitchery').innerHTML = 'NO'
        globalNuevaFicha.NUEVA_FICHA.tieneCorreo = false;
        getNode('#txtCorreoNuevaFicha').setAttribute('disabled', true)
        getNode('#txtCorreoNuevaFicha').value = globalNuevaFicha.NUEVA_FICHA.correoPorDefecto;
        globalNuevaFicha.NUEVA_FICHA.correo = '';
      }
      $('#txtCorreoNuevaFicha').valid();
    }
  },

  obtenerCorreoPorDefecto() {
    request.obtenerCorreoPorDefecto().then(response => {
      globalNuevaFicha.NUEVA_FICHA.correoPorDefecto = response.data.mail.toUpperCase();
    });

    getNode('#txtCorreoNuevaFicha').addEventListener('blur', (e) => {
      globalNuevaFicha.NUEVA_FICHA.correo = e.currentTarget.value.toUpperCase().trim();
    });
  },

  listarSede() {
    request.listarSede().then((sedes) => {
      getNode('#cboSedeNuevaFicha').innerHTML = createSelectOptions(sedes, 'codigoSede', 'nombre');
    });
  },

  listarArea() {
    getNode('#cboSedeNuevaFicha').onchange = (e) => {
      getNode('#cboAreaNuevaFicha').innerHTML = '<option value="0">[SELECCIONAR]</option>';
      getNode('#cboCargoNuevaFicha').innerHTML = '<option value="0">[SELECCIONAR]</option>';

      $(e.currentTarget).valid();
      if (!isNaN(e.currentTarget.value)) {
        let codigoSede = parseInt(e.currentTarget.value);
        if (codigoSede !== 0) {
          request.listarArea(codigoSede).then((areas) => {
            getNode('#cboAreaNuevaFicha').innerHTML = createSelectOptions(areas, 'codigoArea', 'nombre');
          });
        }
      }
    }
  },

  listarCargo() {
    getNode('#cboAreaNuevaFicha').onchange = (e) => {
      getNode('#cboCargoNuevaFicha').innerHTML = '<option value="0">[SELECCIONAR]</option>';

      $(e.currentTarget).valid();
      if (!isNaN(e.currentTarget.value)) {
        let codigoSede = parseInt(getNode('#cboSedeNuevaFicha').value);
        let codigoArea = parseInt(e.currentTarget.value);
        let data = {codigoSede: codigoSede, codigoArea: codigoArea};
        if (codigoArea !== 0) {
          request.listarCargo(codigoArea).then((cargos) => {
            getNode('#cboCargoNuevaFicha').innerHTML = createSelectOptions(cargos, 'codigoCargo', 'nombre');
            return data;
          }).then((data) => {
            request.obtenerSedeArea(data.codigoSede, data.codigoArea).then((response) => {
              globalNuevaFicha.NUEVA_FICHA.codigoSedeArea = response;
            });
          });
        }
      }
    }

    getNode('#cboCargoNuevaFicha').onchange = (e) => {
      $(e.currentTarget).valid();
      if (!isNaN(e.currentTarget.value)) {
        let codigoArea = parseInt(getNode('#cboAreaNuevaFicha').value);
        let codigoCargo = parseInt(e.currentTarget.value);
        if (codigoCargo !== 0) {
          request.obtenerAreaCargo(codigoArea, codigoCargo).then((response) => {
            globalNuevaFicha.NUEVA_FICHA.codigoAreaCargo = response;
            request.validarVacanteFicha({codigoSedeArea: globalNuevaFicha.NUEVA_FICHA.codigoSedeArea, codigoAreaCargo: globalNuevaFicha.NUEVA_FICHA.codigoAreaCargo})
              .then(result => result.data)
              .then(data => {
                let cargo = getSelectedText('#cboCargoNuevaFicha'), area = getSelectedText('#cboAreaNuevaFicha'),
                  sede = getSelectedText('#cboSedeNuevaFicha')
                if (!data.status) {
                  jAlert({
                    type: 'warning',
                    content: `El cargo de <span class="text-black">${cargo}</span> del área <span class="text-black">${area}</span> correspondiente a la sede 
                              <span class="text-black">${sede}</span>, no cuenta con vacantes necesarias para realizar el registro
                              de la ficha. <br>
                              Comuniquese con <span class="text-primary">PRESIDENCIA</span> para que pueda
                              habilitarle más vacantes.`,
                    buttons: {left: 'Aceptar'}
                  })
                  nuevaFicha.limpiar()

                } else {
                  globalNuevaFicha.NUEVA_FICHA.flags.vacante = true;
                }
              })
              .catch(err => console.error(err))
          });
        }
      }
    }
  },

  listarTipoDocumento() {
    request.listarTipoDocumento().then((tipoDocumentos) => {
      getNode('#cboTipoDocumentoNuevaFicha').innerHTML = createSelectOptions(tipoDocumentos, 'codigoTipoDocumento', 'descripcionCorta');
      return tipoDocumentos;
    }).then((array) => {
      getNode('#cboTipoDocumentoNuevaFicha').onchange = (e) => {
        $(e.currentTarget).valid();
        if (!isNaN(e.currentTarget.value)) {
          getNode('#linkValidarDNI').innerHTML = ``;
          getNode('#respuestaHTML').innerHTML = ``;
          globalNuevaFicha.NUEVA_FICHA.persona = '';
          globalNuevaFicha.NUEVA_FICHA.validadoPoReniec = false;
          globalNuevaFicha.NUEVA_FICHA.serviceFailure.apellidoPaterno = '';
          globalNuevaFicha.NUEVA_FICHA.serviceFailure.apellidoMaterno = '';
          globalNuevaFicha.NUEVA_FICHA.serviceFailure.nombres = '';
          globalNuevaFicha.NUEVA_FICHA.serviceFailure.dni = '';
          globalNuevaFicha.NUEVA_FICHA.errorReniec = false;
          getNode('#ventanaEmergenciaNuevaFicha').innerHTML = '';

          let codigoTipoDocumento = parseInt(e.currentTarget.value);
          if (codigoTipoDocumento !== 0) {
            array.map((data) => {
              if (codigoTipoDocumento === data.codigoTipoDocumento) {
                getNode('#txtNumeroDocumentoNuevaFicha').removeAttribute('disabled')
                getNode('#txtNumeroDocumentoNuevaFicha').value = '';
                getNode('#txtNumeroDocumentoNuevaFicha').setAttribute('minlength', data.longitud)
                getNode('#txtNumeroDocumentoNuevaFicha').setAttribute('maxlength', data.longitud)
                $(getNode('#txtNumeroDocumentoNuevaFicha')).off();
                data.tipoEntrada === 'N' ? "" + $(getNode('#txtNumeroDocumentoNuevaFicha')).validCampo('1234567890') : "" + $(getNode('#txtNumeroDocumentoNuevaFicha')).validCampo('1234567890abcdefghijklmnopqrstuvwxyz');
                globalNuevaFicha.NUEVA_FICHA.tipoDocumento.codigoTipoDocumento = codigoTipoDocumento;
                globalNuevaFicha.NUEVA_FICHA.tipoDocumento.longitud = parseInt(data.longitud);
                globalNuevaFicha.NUEVA_FICHA.tipoDocumento.tipoEntrada = data.tipoEntrada;

                // dibujar link de validacion con reniec
                getNode('#linkValidarDNI').innerHTML = ``;
                if (codigoTipoDocumento === 1) { // igual a dni
                  getNode('#linkValidarDNI').innerHTML = `<a id="consultarDNI" class="text-bold text-success-800 border" title="[VALIDA CON RENIEC LA EXISTENCIA DEL DNI INGRESADO]"><i class="fa fa-search position-left"></i>Consultar DNI</a> 
                                                          <span style="display:none" id="gifCargando"><img src="../img/cargando.gif"/> <b>Cargando...</b></span>`;
                  nuevaFicha.consultarDNI();
                }
              }
            });
          } else {
            getNode('#txtNumeroDocumentoNuevaFicha').setAttribute('disabled', true);
            getNode('#txtNumeroDocumentoNuevaFicha').value = '';
          }
        }
        getNode('#txtNumeroDocumentoNuevaFicha').addEventListener('blur', (e) => {
          globalNuevaFicha.NUEVA_FICHA.tipoDocumento.numeroDocumento = e.currentTarget.value;
        });
        validFormRegistrarFicha.reglas();
      }
    });
  },

  consultarDNI() {
    let flag = false;
    getNode('#consultarDNI').addEventListener('click', (e) => {
      let numeroDocumento = globalNuevaFicha.NUEVA_FICHA.tipoDocumento.numeroDocumento.trim();
      let longitudTipoDocumento = globalNuevaFicha.NUEVA_FICHA.tipoDocumento.longitud;
      // ¿El numero de documento tiene la longitud igual a 8?
      if (numeroDocumento.length === longitudTipoDocumento) { // SI
        getNode('#consultarDNI').setAttribute('style', 'display:none');
        getNode('#gifCargando').setAttribute('style', 'display:block');
        if (flag) {
          flag = false;
          nuevaFicha.consultarDNIAfter(flag);
        } else {
          anularFichaMethods.validarExistenciaFichaAnulada().then(response => {
            // hay fichas anuladas, entonces no ejecutar el metodo validar
            // existencia numero documento
            if (response) {
              // Ejecutar método que valida el dni ingresado con el servicio TECACTUS -> (RENIEC)
              request.consultarDNI(numeroDocumento).then(response => {

                globalNuevaFicha.NUEVA_FICHA.persona = response;
                let respuestaHTML = ``;
                // ¿ el método devolvió a la persona ?
                if (!globalNuevaFicha.NUEVA_FICHA.persona.empty) { // SI
                  globalNuevaFicha.NUEVA_FICHA.validadoPoReniec = true;
                  respuestaHTML = `
                  <div class="alert alert-success alert-styled-left alert-arrow-left alert-bordered">
                    <span class="text-bold">RESPUESTA DE RENIEC: </span> 
                    ${globalNuevaFicha.NUEVA_FICHA.persona.apellidoPaterno + ' '
                    + globalNuevaFicha.NUEVA_FICHA.persona.apellidoMaterno + ' '
                    + globalNuevaFicha.NUEVA_FICHA.persona.nombres +
                    ' (<span class="text-semibold">' + globalNuevaFicha.NUEVA_FICHA.persona.dni + '</span>)'}
                  </div>`;
                } else { // NO
                  respuestaHTML = `
                  <div class="alert alert-danger alert-styled-left alert-arrow-left alert-bordered">
                    <span class="text-bold">RESPUESTA DE RENIEC: </span> ${globalNuevaFicha.NUEVA_FICHA.persona.message}
                  </div>`;
                }
                getNode('#respuestaHTML').innerHTML = respuestaHTML;
                flag = true;
                nuevaFicha.consultarDNIAfter(flag);
              }).catch(error => {
                flag = true;
                nuevaFicha.consultarDNIAfter(flag);
                globalNuevaFicha.NUEVA_FICHA.errorReniec = true;
                if (error.statusCodeTecactus === -1) {
                  let ventanaEmergenciaHTML = `
                      <div class="panel border-danger">
                        <div class="panel-heading bg-danger">
                          <h6 class="panel-title"><i class="fa fa-warning"></i> &nbsp; Ventana de emergencia</h6>
                          <a class="heading-elements-toggle"><i class="icon-more"></i></a>
                        </div>
                        <div class="panel-body">
                          <div class="row">
                            <div class="col-md-12">
                              <div class="alert alert-warning">
                                <span class="text-semibold">FALLA DEL SERVICIO TECACTUS (<ins><i>Servicio que se conecta con RENIEC para la validación de DNI</i></ins>) </span> <br/>
                                <span>
                                  Al parecer el servicio <ins>TECACTUS</ins> está fallando, asimismo se ha activado el <b>plan de contingencia</b>, el cuál
                                  cubre la necesidad parcial del registro de ficha. Por favor ingrese los datos que se le solicitan en está ventana, Gracias.
                                </span> <br/>
                                <span class="text-muted text-semibold">* El servicio se estará restableciendo pronto.</span>
                              </div>
                            </div>
                          </div>
                          <div class="row">
                            <div class="col-md-4">
                              <div class="form-group">
                                <label for="txtApellidoPaterno" class="text-semibold">Apellido Paterno <span class="text-danger">*</span></label>
                                <input type="text" class="form-control text-uppercase" placeholder="Ingresar apellido paterno" id="txtApellidoPaterno" name="txtApellidoPaterno" maxlength="50" autocomplete="off" required>
                              </div>
                            </div>
                            <div class="col-md-4">
                              <div class="form-group">
                                <label for="txtApellidoMaterno" class="text-semibold">Apellido Materno <span class="text-danger">*</span></label>
                                <input type="text" class="form-control text-uppercase" placeholder="Ingresar apellido materno" id="txtApellidoMaterno" name="txtApellidoMaterno" maxlength="50" autocomplete="off" required>
                              </div>
                            </div>
                            <div class="col-md-4">
                              <div class="form-group">
                                <label for="txtNombres" class="text-semibold">Nombres <span class="text-danger">*</span></label>
                                <input type="text" class="form-control text-uppercase" placeholder="Ingresar apellido paterno" id="txtNombres" name="txtNombres" maxlength="50" autocomplete="off" required>
                              </div>
                            </div>
                          </div>
                        </div>
                      </div>`;
                  getNode('#ventanaEmergenciaNuevaFicha').innerHTML = ventanaEmergenciaHTML;
                  $(getNode('#txtApellidoPaterno')).validCampo('abcdefghijklmnñopqrstuvwxyzáéíóú ');
                  $(getNode('#txtApellidoMaterno')).validCampo('abcdefghijklmnñopqrstuvwxyzáéíóú ');
                  $(getNode('#txtNombres')).validCampo('abcdefghijklmnñopqrstuvwxyzáéíóú ');
                  nuevaFicha.llenarDatosServiceFailure();
                  validFormRegistrarFicha.reglas();
                }
              });
            }
            // ejecutar los metodos con normalidad
            else {
              // Ejecutar método que valida la existencia del número de documento ingresado
              let tipoDocumentoJson = globalNuevaFicha.NUEVA_FICHA.tipoDocumento;
              request.validarExistenciaNumeroDocumento(tipoDocumentoJson).then(response => {

                // ¿El número de documento ingresado existe en el sistema?
                if (response.status) { // NO
                  // Ejecutar método que valida el dni ingresado con el servicio TECACTUS -> (RENIEC)
                  request.consultarDNI(numeroDocumento).then(response => {

                    globalNuevaFicha.NUEVA_FICHA.persona = response;
                    let respuestaHTML = ``;
                    // ¿ el método devolvió a la persona ?
                    if (!globalNuevaFicha.NUEVA_FICHA.persona.empty) { // SI
                      globalNuevaFicha.NUEVA_FICHA.validadoPoReniec = true;
                      respuestaHTML = `
                  <div class="alert alert-success alert-styled-left alert-arrow-left alert-bordered">
                    <span class="text-bold">RESPUESTA DE RENIEC: </span> 
                    ${globalNuevaFicha.NUEVA_FICHA.persona.apellidoPaterno + ' '
                        + globalNuevaFicha.NUEVA_FICHA.persona.apellidoMaterno + ' '
                        + globalNuevaFicha.NUEVA_FICHA.persona.nombres +
                        ' (<span class="text-semibold">' + globalNuevaFicha.NUEVA_FICHA.persona.dni + '</span>)'}
                  </div>`;
                    } else { // NO
                      respuestaHTML = `
                  <div class="alert alert-danger alert-styled-left alert-arrow-left alert-bordered">
                    <span class="text-bold">RESPUESTA DE RENIEC: </span> ${globalNuevaFicha.NUEVA_FICHA.persona.message}
                  </div>`;
                    }
                    getNode('#respuestaHTML').innerHTML = respuestaHTML;
                    flag = true;
                    nuevaFicha.consultarDNIAfter(flag);
                  }).catch(error => {
                    flag = true;
                    nuevaFicha.consultarDNIAfter(flag);
                    globalNuevaFicha.NUEVA_FICHA.errorReniec = true;
                    if (error.statusCodeTecactus === -1) {
                      let ventanaEmergenciaHTML = `
                      <div class="panel border-danger">
                        <div class="panel-heading bg-danger">
                          <h6 class="panel-title"><i class="fa fa-warning"></i> &nbsp; Ventana de emergencia</h6>
                          <a class="heading-elements-toggle"><i class="icon-more"></i></a>
                        </div>
                        <div class="panel-body">
                          <div class="row">
                            <div class="col-md-12">
                              <div class="alert alert-warning">
                                <span class="text-semibold">FALLA DEL SERVICIO TECACTUS (<ins><i>Servicio que se conecta con RENIEC para la validación de DNI</i></ins>) </span> <br/>
                                <span>
                                  Al parecer el servicio <ins>TECACTUS</ins> está fallando, asimismo se ha activado el <b>plan de contingencia</b>, el cuál
                                  cubre la necesidad parcial del registro de ficha. Por favor ingrese los datos que se le solicitan en está ventana, Gracias.
                                </span> <br/>
                                <span class="text-muted text-semibold">* El servicio se estará restableciendo pronto.</span>
                              </div>
                            </div>
                          </div>
                          <div class="row">
                            <div class="col-md-4">
                              <div class="form-group">
                                <label for="txtApellidoPaterno" class="text-semibold">Apellido Paterno <span class="text-danger">*</span></label>
                                <input type="text" class="form-control text-uppercase" placeholder="Ingresar apellido paterno" id="txtApellidoPaterno" name="txtApellidoPaterno" maxlength="50" autocomplete="off" required>
                              </div>
                            </div>
                            <div class="col-md-4">
                              <div class="form-group">
                                <label for="txtApellidoMaterno" class="text-semibold">Apellido Materno <span class="text-danger">*</span></label>
                                <input type="text" class="form-control text-uppercase" placeholder="Ingresar apellido materno" id="txtApellidoMaterno" name="txtApellidoMaterno" maxlength="50" autocomplete="off" required>
                              </div>
                            </div>
                            <div class="col-md-4">
                              <div class="form-group">
                                <label for="txtNombres" class="text-semibold">Nombres <span class="text-danger">*</span></label>
                                <input type="text" class="form-control text-uppercase" placeholder="Ingresar apellido paterno" id="txtNombres" name="txtNombres" maxlength="50" autocomplete="off" required>
                              </div>
                            </div>
                          </div>
                        </div>
                      </div>`;
                      getNode('#ventanaEmergenciaNuevaFicha').innerHTML = ventanaEmergenciaHTML;
                      $(getNode('#txtApellidoPaterno')).validCampo('abcdefghijklmnñopqrstuvwxyzáéíóú ');
                      $(getNode('#txtApellidoMaterno')).validCampo('abcdefghijklmnñopqrstuvwxyzáéíóú ');
                      $(getNode('#txtNombres')).validCampo('abcdefghijklmnñopqrstuvwxyzáéíóú ');
                      nuevaFicha.llenarDatosServiceFailure();
                      validFormRegistrarFicha.reglas();
                    }
                  });
                } else { // SI
                  warningMessage(response.message);
                }
              });
            }
          });
        }
      } else { // NO
        warningMessage(`El número de documento no es un DNI válido, por favor ingrese <mark>${longitudTipoDocumento}</mark> dígitos`);
      }
    });
  },

  llenarDatosServiceFailure() {
    if (globalNuevaFicha.NUEVA_FICHA.errorReniec) {
      globalNuevaFicha.NUEVA_FICHA.serviceFailure.dni = globalNuevaFicha.NUEVA_FICHA.tipoDocumento.numeroDocumento;
      getNode('#txtApellidoPaterno').addEventListener('blur', (e) => {
        globalNuevaFicha.NUEVA_FICHA.serviceFailure.apellidoPaterno = e.currentTarget.value.toUpperCase().trim();
      });
      getNode('#txtApellidoMaterno').addEventListener('blur', (e) => {
        globalNuevaFicha.NUEVA_FICHA.serviceFailure.apellidoMaterno = e.currentTarget.value.toUpperCase().trim();
      });
      getNode('#txtNombres').addEventListener('blur', (e) => {
        globalNuevaFicha.NUEVA_FICHA.serviceFailure.nombres = e.currentTarget.value.toUpperCase().trim();
      });
    }
  },

  consultarDNIAfter(flag) {
    if (flag) {
      getNode('#consultarDNI').setAttribute('style', 'display:block');
      getNode('#gifCargando').setAttribute('style', 'display:none');
      getNode('#consultarDNI').innerHTML = '<i class="fa fa-undo position-left"></i> Consultar otro DNI'
      getNode('#consultarDNI').setAttribute('class', 'text-bold text-danger-800');
      getNode('#txtNumeroDocumentoNuevaFicha').setAttribute('disabled', true);
    } else {
      getNode('#consultarDNI').setAttribute('style', 'display:block');
      getNode('#gifCargando').setAttribute('style', 'display:none');
      getNode('#consultarDNI').innerHTML = '<i class="fa fa-search position-left"></i> Consultar DNI'
      getNode('#consultarDNI').setAttribute('class', 'text-bold text-success-800');
      getNode('#txtNumeroDocumentoNuevaFicha').removeAttribute('disabled');
      getNode('#txtNumeroDocumentoNuevaFicha').value = '';
      getNode('#respuestaHTML').innerHTML = '';
      globalNuevaFicha.NUEVA_FICHA.tipoDocumento.numeroDocumento = '';
      globalNuevaFicha.NUEVA_FICHA.persona = '';
      globalNuevaFicha.NUEVA_FICHA.validadoPoReniec = false;
      globalNuevaFicha.NUEVA_FICHA.serviceFailure.apellidoPaterno = '';
      globalNuevaFicha.NUEVA_FICHA.serviceFailure.apellidoMaterno = '';
      globalNuevaFicha.NUEVA_FICHA.serviceFailure.nombres = '';
      globalNuevaFicha.NUEVA_FICHA.serviceFailure.dni = '';
      globalNuevaFicha.NUEVA_FICHA.errorReniec = false;
      getNode('#ventanaEmergenciaNuevaFicha').innerHTML = '';
    }
  },

  validarNumeroDocumentoCorreoElectronico() {
    return new Promise((resolve, reject) => {
      let flag = true;


      let errorReniec = globalNuevaFicha.NUEVA_FICHA.errorReniec;
      let validadoPorReniec = globalNuevaFicha.NUEVA_FICHA.validadoPoReniec;
      let codigoTipoDocumento = globalNuevaFicha.NUEVA_FICHA.tipoDocumento.codigoTipoDocumento;

      // si errorReniec es 'false' y validadoPorReniec es 'false'
      // aun no ha consultado el dni
      if (codigoTipoDocumento === 1 && !errorReniec && !validadoPorReniec) {
        warningMessage('Por favor, valide el dni ingresado dando clic en "Consultar DNI"');
        flag = false;
        resolve(flag);
        return;
      }

      // si errorReniec es 'true' y validadoPorReniec es 'false' 
      // ó 
      // si errorReniec es 'false' y validadoPorReniec es 'true'
      // 1era condición: salió error en reniec y aún asi puede ser registrado
      // 2da condición: no slaio error en reniec el DNI ha sido validado
      if (codigoTipoDocumento === 1 && errorReniec && !validadoPorReniec || !errorReniec && validadoPorReniec) {
        // si tieneCorreo es 'true'
        // ejecutar metodo que valida la existencia del correo
        let tieneCorreo = globalNuevaFicha.NUEVA_FICHA.tieneCorreo;
        if (tieneCorreo) {

          // si hay fichas anuladas entonces no ejecutar el metodo
          //que valida la existencia de correo electronico
          anularFichaMethods.validarExistenciaFichaAnulada().then(response => {
            if (response) { // si hay fichas anuladas
              flag = true;
              resolve(flag);
            } else {
              let correo = globalNuevaFicha.NUEVA_FICHA.correo.toUpperCase().trim();
              request.validarExistenciaCorreo(correo).then(response => {
                // si encontro un correo existente a otra persona
                if (!response.status) {
                  warningMessage(response.message);
                  flag = false;
                  resolve(flag);
                  return;
                } else {
                  flag = true;
                  resolve(flag);
                }
              });
            }
          });
        } else {
          flag = true;
          resolve(flag);
        }
      } else if (codigoTipoDocumento !== 1) {
        // si tieneCorreo es 'true'
        // ejecutar metodo que valida la existencia del correo
        let tieneCorreo = globalNuevaFicha.NUEVA_FICHA.tieneCorreo;
        if (tieneCorreo) {

          // si hay fichas anuladas entonces no ejecutar el metodo
          //que valida la existencia de correo electronico
          anularFichaMethods.validarExistenciaFichaAnulada().then(response => {
            if (response) { // si hay fichas anuladas
              flag = true;
              resolve(flag);
            } else {
              let correo = globalNuevaFicha.NUEVA_FICHA.correo.toUpperCase().trim();
              request.validarExistenciaCorreo(correo).then(response => {
                // si encontro un correo existente a otra persona
                if (!response.status) {
                  warningMessage(response.message);
                  flag = false;
                  resolve(flag);
                  return;
                } else {
                  flag = true;
                  resolve(flag);
                }
              });
            }
          });
        } else {
          flag = true;
          resolve(flag);
        }
      }
    });
  },

  registrarFicha() {
    let obj = {
      type: 'confirm',
      content: '¿Está seguro que desea registrar la ficha?',
      buttons: {
        left: 'SI',
        right: 'NO'
      }
    }
    jAlert(obj).then(flag => {
      if (flag) {
        request.registrarFicha(globalNuevaFicha.NUEVA_FICHA).then(response => {
          if (response.status) {
            $('#tblListadoFichaPendiente').DataTable().ajax.reload();
            let obj = {
              type: 'success',
              content: response.message,
              buttons: {
                left: 'Aceptar'
              }
            }
            jAlert(obj);
            nuevaFicha.limpiar();
          } else {
            let obj = {
              type: 'error',
              content: response.message,
              buttons: {
                left: 'Aceptar'
              }
            }
            jAlert(obj);
          }
        });
      }
    });
  },

  habilitarFicha() {
    request.habilitarFicha(globalNuevaFicha.NUEVA_FICHA).then(response => {
      if (response.status) {
        $('#tblListadoFichaPendiente').DataTable().ajax.reload();
        let obj = {
          type: 'success',
          content: response.message,
          buttons: {
            left: 'Aceptar'
          }
        }
        jAlert(obj);
        nuevaFicha.limpiar();
      } else {
        let obj = {
          type: 'error',
          content: response.message,
          buttons: {
            left: 'Aceptar'
          }
        }
        jAlert(obj);
      }
    });
  },

  limpiar() {
    globalNuevaFicha = {
      NUEVA_FICHA: {
        codigoSedeArea: 0,
        codigoAreaCargo: 0,
        flags: {
          vacante: false
        },
        tipoDocumento: {
          codigoTipoDocumento: 0,
          longitud: 0,
          tipoEntrada: '',
          numeroDocumento: ''
        },
        tieneCorreo: true,
        correoPorDefecto: '',
        correo: '',
        validadoPoReniec: false,
        persona: '',
        serviceFailure: {
          apellidoPaterno: '',
          apellidoMaterno: '',
          nombres: '',
          dni: ''
        }
      }
    };

    this.obtenerCorreoPorDefecto();

    // set values
    $(getNode('#cboSedeNuevaFicha')).val(0).trigger('change');
    $(getNode('#cboAreaNuevaFicha')).val(0).trigger('change');
    $(getNode('#cboCargoNuevaFicha')).val(0).trigger('change');
    $(getNode('#cboTipoDocumentoNuevaFicha')).val(0).trigger('change');
    getNode('#txtNumeroDocumentoNuevaFicha').value = '';
    getNode('#txtNumeroDocumentoNuevaFicha').setAttribute('disabled', true);
    getNode('#txtCorreoNuevaFicha').value = '';

    getNode('#btnRegistrarNuevaFicha').removeAttribute('disabled');

    let validator = $("#formNuevaFicha").validate();
    validator.resetForm();

    $(getNode('#modalRegistrarNuevaFicha')).modal('hide');
  }
}

const anularFichaMethods = {
  validarExistenciaFichaAnulada() {
    return new Promise((resolve, reject) => {
      request.validarExistenciaFichaAnulada(globalNuevaFicha.NUEVA_FICHA.tipoDocumento).then(response => {
        // ¿encontró fichas anuladas?
        if (response.status) { // si
          request.obtenerCodigoPersonaPorTipoDocumentoYNumeroDocumento(globalNuevaFicha.NUEVA_FICHA.tipoDocumento).then(response => {
            // ¿encontró el codigo de la persona con ficha anulada?
            if (response.status) {
              globalNuevaFicha.NUEVA_FICHA.codigoPersona = response.data.getResultedKey;
              request.validarFichaActiva(globalNuevaFicha.NUEVA_FICHA).then(response => {
                // ¿encontró fichas activas?
                if (response.status) { // si
                  warningMessage(response.message);
                } else {
                  resolve(true);
                }
              });
            }
          });
        } else { // no
          resolve(false);
        }
      });
    });
  }
}


const validFormRegistrarFicha = {
  reglas() {
    // select sede
    $(getNode('#cboSedeNuevaFicha')).rules('add', {
      valueNotEquals: '0'
    });

    // select área
    $(getNode('#cboAreaNuevaFicha')).rules('add', {
      valueNotEquals: '0'
    });

    // select cargo
    $(getNode('#cboCargoNuevaFicha')).rules('add', {
      valueNotEquals: '0'
    });

    // select tipo de documento
    $(getNode('#cboTipoDocumentoNuevaFicha')).rules('add', {
      valueNotEquals: '0'
    });

    // input numero documento
    if (globalNuevaFicha.NUEVA_FICHA.tipoDocumento.tipoEntrada === 'N') {
      $('#txtNumeroDocumentoNuevaFicha').rules('remove', 'alphanumeric');
      $(getNode('#txtNumeroDocumentoNuevaFicha')).rules('add', {
        number: true
      });
    } else if (globalNuevaFicha.NUEVA_FICHA.tipoDocumento.tipoEntrada === 'A') {
      $('#txtNumeroDocumentoNuevaFicha').rules('remove', 'number');
      $(getNode('#txtNumeroDocumentoNuevaFicha')).rules('add', {
        alphanumeric: true
      });
    }

    // apellido paterno
    $(getNode('#txtApellidoPaterno')).rules('add', {
      required: true,
      lettersonly: true
    });

    // apellido paterno
    $(getNode('#txtApellidoMaterno')).rules('add', {
      required: true,
      lettersonly: true
    });

    // apellido paterno
    $(getNode('#txtNombres')).rules('add', {
      required: true,
      lettersonly: true
    });

  },

  validarFormularioRegistrarFicha() {
    $(getNode('#formNuevaFicha')).validate({
      submitHandler: function (form) {
        nuevaFicha.validarNumeroDocumentoCorreoElectronico().then((response) => {
          if (response) {
            getNode('#btnRegistrarNuevaFicha').setAttribute('disabled', true);
            // si hay fichas anuladas entonces no ejecutar el metodo
            //que valida la existencia de correo electronico
            anularFichaMethods.validarExistenciaFichaAnulada().then(response => {
              if (response) {
                jAlert({
                  type: 'warning',
                  content: `
                    El sistema ha detectado que la persona que intenta registrar tiene una o más fichas anulada(s), 
                    para más información diríjase al módulo de <span class="label label-default">consultas / fichas </span> y búsquelo por el número de documento 
                    <span class="text-bold">${globalNuevaFicha.NUEVA_FICHA.tipoDocumento.numeroDocumento}</span> <hr/>
                    <h5><b>¿Desea registrarlo de todas formas?</b></h5>`,
                  buttons: {
                    left: 'SI',
                    right: 'NO'
                  }
                })
                  .then(flag => {
                    if (flag) {
                      nuevaFicha.habilitarFicha();
                    }
                    console.log('desbloquear');
                    getNode('#btnRegistrarNuevaFicha').removeAttribute('disabled');
                  });
              } else {
                nuevaFicha.registrarFicha();
                console.log('desbloquear');
                getNode('#btnRegistrarNuevaFicha').removeAttribute('disabled');
              }
            });
          }
        });
        return false;
      }
    });
  }
}

nuevaFicha.obtenerCorreoPorDefecto();
nuevaFicha.abrirModal();
nuevaFicha.cerrarModal();
incializeComponents.select2ById('cboSedeNuevaFicha');
incializeComponents.select2ById('cboAreaNuevaFicha');
incializeComponents.select2ById('cboCargoNuevaFicha');
incializeComponents.select2ById('cboTipoDocumentoNuevaFicha');
nuevaFicha.listarSede();
nuevaFicha.listarArea();
nuevaFicha.listarCargo();
nuevaFicha.listarTipoDocumento();
validFormRegistrarFicha.validarFormularioRegistrarFicha();
validFormRegistrarFicha.reglas();
