$(function () {
  init();
});

function init() {
  ingresarTrismegistoPlanilla();
}

//INGRESAR A TRISMEGISTO PLANILLA
function ingresarTrismegistoPlanilla() {
  // CLICK AL BOTON
  const btnIngresar = $('#btnIngresar');
  btnIngresar.on('click', function (e) {
    let usuario = $('#txtUsuario').val()
    let contrasenia = $('#txtContrasena').val()
    if (contrasenia !== "") {
      validarUsuario({usuario: usuario, contrasenia: contrasenia});
    } else {
      showAlertMessage()
    }

  });

  // CUANDO PRESIONE ENTER
  document.addEventListener('keydown', function (e) {
    if (e.keyCode === 13) {
      let usuario = $('#txtUsuario').val()
      let contrasenia = $('#txtContrasena').val()
      if (contrasenia !== "") {
        validarUsuario({usuario: usuario, contrasenia: contrasenia});
      } else {
        showAlertMessage()
      }
    }
  });
}

//VALIDAR USUARIO
function validarUsuario(obj) {

  const json = {
    txtUsuario: obj.usuario,
    txtContrasenia: obj.contrasenia
  };

  $.ajax({
    url: '../UsuarioServlet?accion=validarUsuario',
    type: 'POST',
    data: {
      json: JSON.stringify(json)
    },
    dataType: 'json',
    beforeSend: function (xhr) {
      load('Verificando usuario ingresado');
    },
    success: function (data, textStatus, jqXHR) {
      dismissAlertMessage();
      const status = data.status;
      if (status) {
        window.location.href = 'main.jsp';
      } else {
        document.querySelector('#txtContrasena').value = ''
        document.querySelector('#txtContrasena').focus()
        showAlertMessage();
      }
    },
    complete: function () {
      unload();
    }
  });
}

// ---------------------------------------------------------------------------//
// --------------------------------- EFECTO CARGAR ---------------------------//
// ---------------------------------------------------------------------------//

/* cierra el efecto cargar */
function unload() {
  $.unblockUI();
}

/* efecto cargar */
function load(msg) {
  $.blockUI({
    message: '<span class="text-semibold"><i class="icon-hour-glass2 spinner position-left"></i>&nbsp; ' + msg + '...</span>',
    timeout: 20000 * 100, //unblock after 2 seconds
    overlayCSS: {
      backgroundColor: '#1b2024',
      opacity: 0.8,
      zIndex: 1200,
      cursor: 'wait'
    },
    css: {
      border: 0,
      color: '#fff',
      padding: 0,
      zIndex: 1201,
      backgroundColor: 'transparent'
    }
  });
}

// ---------------------------------------------------------------------------//
// --------------------------------- /EFECTO CARGAR --------------------------//
// ---------------------------------------------------------------------------//


// ---------------------------------------------------------------------------//
// --------------------------- /MOSTRAR MENSAJE DE ALERTA --------------------//
// ---------------------------------------------------------------------------//

function showAlertMessage() {
  $('#alertMessageError').fadeIn();
}

function dismissAlertMessage() {
  $('#alertMessageError').fadeOut();
}
// ---------------------------------------------------------------------------//
// --------------------------- /MOSTRAR MENSAJE DE ALERTA --------------------//
// ---------------------------------------------------------------------------//
